/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.templateconcepts;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.emftext.language.templateconcepts.TemplateconceptsFactory
 * @model kind="package"
 * @generated
 */
public interface TemplateconceptsPackage extends EPackage
{
  /**
   * The package name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNAME = "templateconcepts";

  /**
   * The package namespace URI.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_URI = "http://www.emftext.org/language/templateconcepts";

  /**
   * The package namespace name.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  String eNS_PREFIX = "templateconcepts";

  /**
   * The singleton instance of the package.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  TemplateconceptsPackage eINSTANCE = org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl.init();

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.TemplateConceptImpl <em>Template Concept</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.TemplateConceptImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getTemplateConcept()
   * @generated
   */
  int TEMPLATE_CONCEPT = 4;

  /**
   * The feature id for the '<em><b>Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_CONCEPT__EXPRESSION = 0;

  /**
   * The number of structural features of the '<em>Template Concept</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_CONCEPT_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.ForEachImpl <em>For Each</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.ForEachImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getForEach()
   * @generated
   */
  int FOR_EACH = 0;

  /**
   * The feature id for the '<em><b>Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_EACH__EXPRESSION = TEMPLATE_CONCEPT__EXPRESSION;

  /**
   * The feature id for the '<em><b>Variable</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_EACH__VARIABLE = TEMPLATE_CONCEPT_FEATURE_COUNT + 0;

  /**
   * The number of structural features of the '<em>For Each</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int FOR_EACH_FEATURE_COUNT = TEMPLATE_CONCEPT_FEATURE_COUNT + 1;

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.IfImpl <em>If</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.IfImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getIf()
   * @generated
   */
  int IF = 1;

  /**
   * The feature id for the '<em><b>Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IF__EXPRESSION = TEMPLATE_CONCEPT__EXPRESSION;

  /**
   * The number of structural features of the '<em>If</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IF_FEATURE_COUNT = TEMPLATE_CONCEPT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.PlaceholderImpl <em>Placeholder</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.PlaceholderImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getPlaceholder()
   * @generated
   */
  int PLACEHOLDER = 2;

  /**
   * The feature id for the '<em><b>Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLACEHOLDER__EXPRESSION = TEMPLATE_CONCEPT__EXPRESSION;

  /**
   * The number of structural features of the '<em>Placeholder</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int PLACEHOLDER_FEATURE_COUNT = TEMPLATE_CONCEPT_FEATURE_COUNT + 0;

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.TemplateImpl <em>Template</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.TemplateImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getTemplate()
   * @generated
   */
  int TEMPLATE = 3;

  /**
   * The feature id for the '<em><b>Input Meta Class</b></em>' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE__INPUT_META_CLASS = 0;

  /**
   * The number of structural features of the '<em>Template</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int TEMPLATE_FEATURE_COUNT = 1;

  /**
   * The meta object id for the '{@link org.emftext.language.templateconcepts.impl.IfElseImpl <em>If Else</em>}' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see org.emftext.language.templateconcepts.impl.IfElseImpl
   * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getIfElse()
   * @generated
   */
  int IF_ELSE = 5;

  /**
   * The feature id for the '<em><b>Expression</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IF_ELSE__EXPRESSION = TEMPLATE_CONCEPT__EXPRESSION;

  /**
   * The number of structural features of the '<em>If Else</em>' class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  int IF_ELSE_FEATURE_COUNT = TEMPLATE_CONCEPT_FEATURE_COUNT + 0;


  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.ForEach <em>For Each</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>For Each</em>'.
   * @see org.emftext.language.templateconcepts.ForEach
   * @generated
   */
  EClass getForEach();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.templateconcepts.ForEach#getVariable <em>Variable</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Variable</em>'.
   * @see org.emftext.language.templateconcepts.ForEach#getVariable()
   * @see #getForEach()
   * @generated
   */
  EAttribute getForEach_Variable();

  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.If <em>If</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>If</em>'.
   * @see org.emftext.language.templateconcepts.If
   * @generated
   */
  EClass getIf();

  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.Placeholder <em>Placeholder</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Placeholder</em>'.
   * @see org.emftext.language.templateconcepts.Placeholder
   * @generated
   */
  EClass getPlaceholder();

  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.Template <em>Template</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Template</em>'.
   * @see org.emftext.language.templateconcepts.Template
   * @generated
   */
  EClass getTemplate();

  /**
   * Returns the meta object for the reference '{@link org.emftext.language.templateconcepts.Template#getInputMetaClass <em>Input Meta Class</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the reference '<em>Input Meta Class</em>'.
   * @see org.emftext.language.templateconcepts.Template#getInputMetaClass()
   * @see #getTemplate()
   * @generated
   */
  EReference getTemplate_InputMetaClass();

  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.TemplateConcept <em>Template Concept</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>Template Concept</em>'.
   * @see org.emftext.language.templateconcepts.TemplateConcept
   * @generated
   */
  EClass getTemplateConcept();

  /**
   * Returns the meta object for the attribute '{@link org.emftext.language.templateconcepts.TemplateConcept#getExpression <em>Expression</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for the attribute '<em>Expression</em>'.
   * @see org.emftext.language.templateconcepts.TemplateConcept#getExpression()
   * @see #getTemplateConcept()
   * @generated
   */
  EAttribute getTemplateConcept_Expression();

  /**
   * Returns the meta object for class '{@link org.emftext.language.templateconcepts.IfElse <em>If Else</em>}'.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the meta object for class '<em>If Else</em>'.
   * @see org.emftext.language.templateconcepts.IfElse
   * @generated
   */
  EClass getIfElse();

  /**
   * Returns the factory that creates the instances of the model.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @return the factory that creates the instances of the model.
   * @generated
   */
  TemplateconceptsFactory getTemplateconceptsFactory();

  /**
   * <!-- begin-user-doc -->
   * Defines literals for the meta objects that represent
   * <ul>
   *   <li>each class,</li>
   *   <li>each feature of each class,</li>
   *   <li>each enum,</li>
   *   <li>and each data type</li>
   * </ul>
   * <!-- end-user-doc -->
   * @generated
   */
  interface Literals
  {
    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.ForEachImpl <em>For Each</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.ForEachImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getForEach()
     * @generated
     */
    EClass FOR_EACH = eINSTANCE.getForEach();

    /**
     * The meta object literal for the '<em><b>Variable</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute FOR_EACH__VARIABLE = eINSTANCE.getForEach_Variable();

    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.IfImpl <em>If</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.IfImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getIf()
     * @generated
     */
    EClass IF = eINSTANCE.getIf();

    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.PlaceholderImpl <em>Placeholder</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.PlaceholderImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getPlaceholder()
     * @generated
     */
    EClass PLACEHOLDER = eINSTANCE.getPlaceholder();

    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.TemplateImpl <em>Template</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.TemplateImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getTemplate()
     * @generated
     */
    EClass TEMPLATE = eINSTANCE.getTemplate();

    /**
     * The meta object literal for the '<em><b>Input Meta Class</b></em>' reference feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EReference TEMPLATE__INPUT_META_CLASS = eINSTANCE.getTemplate_InputMetaClass();

    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.TemplateConceptImpl <em>Template Concept</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.TemplateConceptImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getTemplateConcept()
     * @generated
     */
    EClass TEMPLATE_CONCEPT = eINSTANCE.getTemplateConcept();

    /**
     * The meta object literal for the '<em><b>Expression</b></em>' attribute feature.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @generated
     */
    EAttribute TEMPLATE_CONCEPT__EXPRESSION = eINSTANCE.getTemplateConcept_Expression();

    /**
     * The meta object literal for the '{@link org.emftext.language.templateconcepts.impl.IfElseImpl <em>If Else</em>}' class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * @see org.emftext.language.templateconcepts.impl.IfElseImpl
     * @see org.emftext.language.templateconcepts.impl.TemplateconceptsPackageImpl#getIfElse()
     * @generated
     */
    EClass IF_ELSE = eINSTANCE.getIfElse();

  }

} //TemplateconceptsPackage
