/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.templateconcepts.call;

import org.eclipse.emf.ecore.EObject;

import org.emftext.language.templateconcepts.Template;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Template Call</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.emftext.language.templateconcepts.call.TemplateCall#getTarget <em>Target</em>}</li>
 *   <li>{@link org.emftext.language.templateconcepts.call.TemplateCall#getParameterModel <em>Parameter Model</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.emftext.language.templateconcepts.call.CallPackage#getTemplateCall()
 * @model
 * @generated
 */
public interface TemplateCall extends EObject
{
  /**
   * Returns the value of the '<em><b>Target</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Target</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Target</em>' reference.
   * @see #setTarget(Template)
   * @see org.emftext.language.templateconcepts.call.CallPackage#getTemplateCall_Target()
   * @model required="true"
   * @generated
   */
  Template getTarget();

  /**
   * Sets the value of the '{@link org.emftext.language.templateconcepts.call.TemplateCall#getTarget <em>Target</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Target</em>' reference.
   * @see #getTarget()
   * @generated
   */
  void setTarget(Template value);

  /**
   * Returns the value of the '<em><b>Parameter Model</b></em>' reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Parameter Model</em>' reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Parameter Model</em>' reference.
   * @see #setParameterModel(EObject)
   * @see org.emftext.language.templateconcepts.call.CallPackage#getTemplateCall_ParameterModel()
   * @model required="true"
   * @generated
   */
  EObject getParameterModel();

  /**
   * Sets the value of the '{@link org.emftext.language.templateconcepts.call.TemplateCall#getParameterModel <em>Parameter Model</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Parameter Model</em>' reference.
   * @see #getParameterModel()
   * @generated
   */
  void setParameterModel(EObject value);

} // TemplateCall
