/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.templateconcepts.call.resource.templatecall.grammar;

public class TemplatecallGrammarInformationProvider {
	
	public final static org.eclipse.emf.ecore.EStructuralFeature ANONYMOUS_FEATURE = org.eclipse.emf.ecore.EcoreFactory.eINSTANCE.createEAttribute();
	static {
		ANONYMOUS_FEATURE.setName("_");
	}
	
	public final static TemplatecallGrammarInformationProvider INSTANCE = new TemplatecallGrammarInformationProvider();
	
	private java.util.Set<String> keywords;
	
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword TEMPLATECALL_0_0_0_0 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword("CALL", org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallPlaceholder TEMPLATECALL_0_0_0_1 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallPlaceholder(org.emftext.language.templateconcepts.call.CallPackage.eINSTANCE.getTemplateCall().getEStructuralFeature(org.emftext.language.templateconcepts.call.CallPackage.TEMPLATE_CALL__TARGET), "QUOTED_34_34", org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE, 0);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword TEMPLATECALL_0_0_0_2 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword("USING", org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallPlaceholder TEMPLATECALL_0_0_0_3 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallPlaceholder(org.emftext.language.templateconcepts.call.CallPackage.eINSTANCE.getTemplateCall().getEStructuralFeature(org.emftext.language.templateconcepts.call.CallPackage.TEMPLATE_CALL__PARAMETER_MODEL), "QUOTED_34_34", org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE, 0);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSequence TEMPLATECALL_0_0_0 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSequence(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE, TEMPLATECALL_0_0_0_0, TEMPLATECALL_0_0_0_1, TEMPLATECALL_0_0_0_2, TEMPLATECALL_0_0_0_3);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallChoice TEMPLATECALL_0_0 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallChoice(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE, TEMPLATECALL_0_0_0);
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallRule TEMPLATECALL_0 = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallRule(org.emftext.language.templateconcepts.call.CallPackage.eINSTANCE.getTemplateCall(), TEMPLATECALL_0_0, org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallCardinality.ONE);
	
	public static String getSyntaxElementID(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSyntaxElement syntaxElement) {
		if (syntaxElement == null) {
			// null indicates EOF
			return "<EOF>";
		}
		for (java.lang.reflect.Field field : org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.class.getFields()) {
			Object fieldValue;
			try {
				fieldValue = field.get(null);
				if (fieldValue == syntaxElement) {
					String id = field.getName();
					return id;
				}
			} catch (Exception e) { }
		}
		return null;
	}
	
	public static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSyntaxElement getSyntaxElementByID(String syntaxElementID) {
		try {
			return (org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSyntaxElement) org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallGrammarInformationProvider.class.getField(syntaxElementID).get(null);
		} catch (Exception e) {
			return null;
		}
	}
	
	public final static org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallRule[] RULES = new org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallRule[] {
		TEMPLATECALL_0,
	};
	
	/**
	 * Returns all keywords of the grammar. This includes all literals for boolean and
	 * enumeration terminals.
	 */
	public java.util.Set<String> getKeywords() {
		if (this.keywords == null) {
			this.keywords = new java.util.LinkedHashSet<String>();
			for (org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallRule rule : RULES) {
				findKeywords(rule, this.keywords);
			}
		}
		return keywords;
	}
	
	/**
	 * Finds all keywords in the given element and its children and adds them to the
	 * set. This includes all literals for boolean and enumeration terminals.
	 */
	private void findKeywords(org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSyntaxElement element, java.util.Set<String> keywords) {
		if (element instanceof org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword) {
			keywords.add(((org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallKeyword) element).getValue());
		} else if (element instanceof org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallBooleanTerminal) {
			keywords.add(((org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallBooleanTerminal) element).getTrueLiteral());
			keywords.add(((org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallBooleanTerminal) element).getFalseLiteral());
		} else if (element instanceof org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallEnumerationTerminal) {
			org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallEnumerationTerminal terminal = (org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallEnumerationTerminal) element;
			for (String key : terminal.getLiteralMapping().keySet()) {
				keywords.add(key);
			}
		}
		for (org.emftext.language.templateconcepts.call.resource.templatecall.grammar.TemplatecallSyntaxElement child : element.getChildren()) {
			findKeywords(child, this.keywords);
		}
	}
	
}
