/*******************************************************************************
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 ******************************************************************************/

package org.emftext.language.templateconcepts.call.resource.templatecall.mopp;

public class TemplatecallMetaInformation implements org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallMetaInformation {
	
	public String getSyntaxName() {
		return "templatecall";
	}
	
	public String getURI() {
		return "http://www.emftext.org/language/templateconcepts/call";
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTextScanner createLexer() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallAntlrScanner(new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallLexer());
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTextParser createParser(java.io.InputStream inputStream, String encoding) {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallParser().createInstance(inputStream, encoding);
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTextPrinter createPrinter(java.io.OutputStream outputStream, org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTextResource resource) {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallPrinter2(outputStream, resource);
	}
	
	public org.eclipse.emf.ecore.EClass[] getClassesWithSyntax() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallSyntaxCoverageInformationProvider().getClassesWithSyntax();
	}
	
	public org.eclipse.emf.ecore.EClass[] getStartSymbols() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallSyntaxCoverageInformationProvider().getStartSymbols();
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallReferenceResolverSwitch getReferenceResolverSwitch() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallReferenceResolverSwitch();
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTokenResolverFactory getTokenResolverFactory() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallTokenResolverFactory();
	}
	
	public String getPathToCSDefinition() {
		return "org.emftext.language.templateconcepts.call/metamodel/templatecall.cs";
	}
	
	public String[] getTokenNames() {
		return org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallParser.tokenNames;
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallTokenStyle getDefaultTokenStyle(String tokenName) {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallTokenStyleInformationProvider().getDefaultTokenStyle(tokenName);
	}
	
	public java.util.Collection<org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallBracketPair> getBracketPairs() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallBracketInformationProvider().getBracketPairs();
	}
	
	public org.eclipse.emf.ecore.EClass[] getFoldableClasses() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallFoldingInformationProvider().getFoldableClasses();
	}
	
	public org.eclipse.emf.ecore.resource.Resource.Factory createResourceFactory() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallResourceFactory();
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallNewFileContentProvider getNewFileContentProvider() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallNewFileContentProvider();
	}
	
	public void registerResourceFactory() {
		org.eclipse.emf.ecore.resource.Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(getSyntaxName(), new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallResourceFactory());
	}
	
	/**
	 * Returns the key of the option that can be used to register a preprocessor that
	 * is used as a pipe when loading resources. This key is language-specific. To
	 * register one preprocessor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getInputStreamPreprocessorProviderOptionKey() {
		return getSyntaxName() + "_" + "INPUT_STREAM_PREPROCESSOR_PROVIDER";
	}
	
	/**
	 * Returns the key of the option that can be used to register a post-processors
	 * that are invoked after loading resources. This key is language-specific. To
	 * register one post-processor for multiple resource types, it must be registered
	 * individually using all keys.
	 */
	public String getResourcePostProcessorProviderOptionKey() {
		return getSyntaxName() + "_" + "RESOURCE_POSTPROCESSOR_PROVIDER";
	}
	
	public String getLaunchConfigurationType() {
		return "org.emftext.language.templateconcepts.call.resource.templatecall.ui.launchConfigurationType";
	}
	
	public org.emftext.language.templateconcepts.call.resource.templatecall.ITemplatecallNameProvider createNameProvider() {
		return new org.emftext.language.templateconcepts.call.resource.templatecall.analysis.TemplatecallDefaultNameProvider();
	}
	
	public String[] getSyntaxHighlightableTokenNames() {
		org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallAntlrTokenHelper tokenHelper = new org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallAntlrTokenHelper();
		java.util.List<String> highlightableTokens = new java.util.ArrayList<String>();
		String[] parserTokenNames = getTokenNames();
		for (int i = 0; i < parserTokenNames.length; i++) {
			// If ANTLR is used we need to normalize the token names
			if (!tokenHelper.canBeUsedForSyntaxHighlighting(i)) {
				continue;
			}
			String tokenName = tokenHelper.getTokenName(parserTokenNames, i);
			if (tokenName == null) {
				continue;
			}
			highlightableTokens.add(tokenName);
		}
		highlightableTokens.add(org.emftext.language.templateconcepts.call.resource.templatecall.mopp.TemplatecallTokenStyleInformationProvider.TASK_ITEM_TOKEN_NAME);
		return highlightableTokens.toArray(new String[highlightableTokens.size()]);
	}
	
}
