/**
 * Copyright (c) 2006-2012
 * Software Technology Group, Dresden University of Technology
 * DevBoost GmbH, Berlin, Amtsgericht Charlottenburg, HRB 140026
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Software Technology Group - TU Dresden, Germany;
 *   DevBoost GmbH - Berlin, Germany
 *      - initial API and implementation
 *  
 */
package org.emftext.language.templateconcepts.impl;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;

import org.emftext.language.templateconcepts.Template;
import org.emftext.language.templateconcepts.TemplateconceptsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Template</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.emftext.language.templateconcepts.impl.TemplateImpl#getInputMetaClass <em>Input Meta Class</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class TemplateImpl extends EObjectImpl implements Template
{
  /**
   * The cached value of the '{@link #getInputMetaClass() <em>Input Meta Class</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getInputMetaClass()
   * @generated
   * @ordered
   */
  protected EClass inputMetaClass;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected TemplateImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return TemplateconceptsPackage.Literals.TEMPLATE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass getInputMetaClass()
  {
    if (inputMetaClass != null && inputMetaClass.eIsProxy())
    {
      InternalEObject oldInputMetaClass = (InternalEObject)inputMetaClass;
      inputMetaClass = (EClass)eResolveProxy(oldInputMetaClass);
      if (inputMetaClass != oldInputMetaClass)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS, oldInputMetaClass, inputMetaClass));
      }
    }
    return inputMetaClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EClass basicGetInputMetaClass()
  {
    return inputMetaClass;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setInputMetaClass(EClass newInputMetaClass)
  {
    EClass oldInputMetaClass = inputMetaClass;
    inputMetaClass = newInputMetaClass;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS, oldInputMetaClass, inputMetaClass));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS:
        if (resolve) return getInputMetaClass();
        return basicGetInputMetaClass();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS:
        setInputMetaClass((EClass)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS:
        setInputMetaClass((EClass)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case TemplateconceptsPackage.TEMPLATE__INPUT_META_CLASS:
        return inputMetaClass != null;
    }
    return super.eIsSet(featureID);
  }

} //TemplateImpl
